=== debian/changelog ===
ceres-solver (1.11.0~dfsg0-2ubuntu0.1) xenial; urgency=medium

  * Fix CeresConfig install rule (LP: #1678043)
  * Fix CeresConfig debian install rule (LP: #1596296)
  * Fix config.h debian install rule

 -- Jeremie Deray <jeremie.deray@canonical.com>  Tue, 17 Nov 2020 14:54:50 +0000

ceres-solver (1.11.0~dfsg0-2) unstable; urgency=medium

  * Upload to unstable

 -- Philipp Huebner <debalance@debian.org>  Fri, 27 Nov 2015 09:50:43 +0100

ceres-solver (1.11.0~dfsg0-1) experimental; urgency=low

  * Imported Upstream version 1.11.0
  * Dropped all patches

 -- Philipp Huebner <debalance@debian.org>  Sat, 17 Oct 2015 15:55:37 +0200

ceres-solver (1.10.0~dfsg0-3) experimental; urgency=low

  * Add missing build depencendy: python-sphinx

 -- Philipp Huebner <debalance@debian.org>  Wed, 22 Jul 2015 14:10:36 +0200

ceres-solver (1.10.0~dfsg0-2) experimental; urgency=low

  * Add versions to some (build-)dependencies
  * Add latest upstream patches
  * Correct debian/rules to work on buildds

 -- Philipp Huebner <debalance@debian.org>  Tue, 21 Jul 2015 22:44:12 +0200

ceres-solver (1.10.0~dfsg0-1) experimental; urgency=low

  * Initial release (Closes: #673238)

 -- Philipp Huebner <debalance@debian.org>  Fri, 20 Mar 2015 11:14:00 +0100
