=== debian/control ===
Source: ceres-solver
Section: math
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Philipp Huebner <debalance@debian.org>
Build-Depends: debhelper (>= 9), cmake (>= 2.8.0),
 		libatlas-base-dev,
 		libgoogle-glog-dev (>= 0.3.1),
 		libgflags-dev,
 		libeigen3-dev (>= 3.2.1),
 		libsuitesparse-dev (>= 1:4.4.3),
 		python-sphinx, python-sphinx-rtd-theme, libjs-mathjax
Standards-Version: 3.9.6
Homepage: http://ceres-solver.org
Vcs-Git: git://anonscm.debian.org/debian-science/packages/ceres-solver.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ceres-solver.git

Package: libceres-dev
Section: libdevel
Architecture: any
Depends: libceres1 (= ${binary:Version}), ${misc:Depends},
 		libgoogle-glog-dev (>= 0.3.1),
 		libgflags-dev,
 		libeigen3-dev (>= 3.2.1),
 		libsuitesparse-dev (>= 1:4.4.3)
Description:  nonlinear least squares minimizer (development files)
 Ceres Solver is an open source C++ library for modeling and solving large, 
 complicated optimization problems.
 It is a feature rich, mature and performant library which has been used
 in production at Google since 2010.
 .
 Ceres Solver can solve two kinds of problems.
  - Non-linear Least Squares problems with bounds constraints.
  - General unconstrained optimization problems.
 .
 This package contains the development header files.

Package: libceres1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: nonlinear least squares minimizer (shared library)
 Ceres Solver is an open source C++ library for modeling and solving large, 
 complicated optimization problems.
 It is a feature rich, mature and performant library which has been used
 in production at Google since 2010.
 .
 Ceres Solver can solve two kinds of problems.
  - Non-linear Least Squares problems with bounds constraints.
  - General unconstrained optimization problems.
 .
 This package contains the shared library.

Package: ceres-solver-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-mathjax, libjs-jquery, libjs-underscore,
Description: documentation for ceres-solver
 Ceres Solver is an open source C++ library for modeling and solving large, 
 complicated optimization problems.
 It is a feature rich, mature and performant library which has been used
 in production at Google since 2010.
 .
 Ceres Solver can solve two kinds of problems.
  - Non-linear Least Squares problems with bounds constraints.
  - General unconstrained optimization problems.
 .
 This package contains the documentation found on http://ceres-solver.org/
 and the examples that were included with the release.
