=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -72,9 +72,6 @@
 add_executable(simple_bundle_adjuster simple_bundle_adjuster.cc)
 target_link_libraries(simple_bundle_adjuster ceres)
 
-add_executable(sampled_function sampled_function.cc)
-target_link_libraries(sampled_function ceres)
-
 if (GFLAGS)
   # The CERES_GFLAGS_NAMESPACE compile definition is NOT stored in
   # CERES_COMPILE_OPTIONS (and thus config.h) as Ceres itself does not
@@ -116,3 +113,6 @@
   target_link_libraries(robot_pose_mle ceres ${GFLAGS_LIBRARIES})
 
 endif (GFLAGS)
+
+add_subdirectory(sampled_function)
+add_subdirectory(slam)
