=== debian/changelog ===
ceres-solver (1.12.0~rc1~dfsg0-1) unstable; urgency=medium

  * New upstream version 1.12.0~rc1
  * Updated patches
  * Restored debian/README.source

 -- Philipp Huebner <debalance@debian.org>  Wed, 19 Oct 2016 09:08:00 +0200

ceres-solver (1.11.0+git20161003-1) unstable; urgency=medium

  * New upstream version 1.11.0+git20161003
  * Added pending upstream patch to fix gradient_checker_test

 -- Philipp Huebner <debalance@debian.org>  Sun, 09 Oct 2016 08:18:49 +0200

ceres-solver (1.11.0+git20160903-1) unstable; urgency=medium

  * New upstream version 1.11.0+git20160903 (Closes: #835037)
  * Remove README.source - no longer needed
  * Update libceres-dev.install

 -- Philipp Huebner <debalance@debian.org>  Sun, 04 Sep 2016 14:18:24 +0200

ceres-solver (1.11.0~dfsg0-5) unstable; urgency=medium

  * Install cmake files into libceres-dev

 -- Philipp Huebner <debalance@debian.org>  Fri, 15 Jul 2016 20:35:35 +0200

ceres-solver (1.11.0~dfsg0-4) unstable; urgency=medium

  * Added patch to allow compiling with GCC 6 (Closes: #811987)
  * Corrected spacing in debian/control
  * Switched to version Format URI in debian/copyright

 -- Philipp Huebner <debalance@debian.org>  Sat, 02 Jul 2016 10:10:08 +0200

ceres-solver (1.11.0~dfsg0-3) unstable; urgency=medium

  * libceres-dev: install config.h (Closes: #823623)
  * Enabled hardening
  * Updated debian/copyright
  * Updated Standards-Version: 3.9.8 (no changes needed)
  * Updated Vcs-* fields in debian/control
  * Fixed some spelling errors that lintian complained about

 -- Philipp Huebner <debalance@debian.org>  Tue, 31 May 2016 13:44:38 +0200
