## ceres-solver 1.12.0~rc2~dfsg0

=== debian/changelog ===
ceres-solver (1.12.0~rc2~dfsg0-1) unstable; urgency=medium

  * New upstream version 1.12.0~rc2

 -- Philipp Huebner <debalance@debian.org>  Sat, 12 Nov 2016 15:45:24 +0100
