## ceres-solver 1.12.0~rc4

=== debian/changelog ===
ceres-solver (1.12.0~rc4-1) unstable; urgency=medium

  * New upstream version 1.12.0~rc4
  * Remove README.source - no longer needed
  * Update debian/copyright

 -- Philipp Huebner <debalance@debian.org>  Wed, 23 Nov 2016 22:37:14 +0100
